#include "configuration.h"

#include "configdialog.h"

ConfigDialog::ConfigDialog()
             :QDialog(NULL, "configdialog", false, 0),
              layout(this, 4),

              serverBox(LANG_SERVER ":", this),
              serverBoxLayout(&serverBox, 8),
              serverAddressLabel(LANG_SERVER_ADDRESS ":", this),
              serverAddressLineEdit(Configuration::getServerIP(), this),
              serverAddressLayout(),
              serverPortLabel(LANG_SERVER_PORT ":", this),
              serverPortLineEdit(QString::number(Configuration::getServerPort()), this),
              serverPortLayout(),

              skinBox(LANG_SKIN ":", this),
              skinBoxLayout(&skinBox, 8),
              skinDirLabel(LANG_SKIN_DIRECTORY ":", this),
              skinDirLineEdit(Configuration::getSkinDir(), this),
              skinDirLayout(),

              buttonLayout(this),
              okButton(LANG_OK, this),
              cancelButton(LANG_CANCEL, this)
{
  serverBox.setFixedHeight(75);
  layout.addWidget(&serverBox);
  serverBoxLayout.addItem(new QSpacerItem(0, 4+8, QSizePolicy::Minimum, QSizePolicy::Fixed));
  serverAddressLabel.setFixedWidth(200);
  serverAddressLayout.addWidget(&serverAddressLabel);
  serverAddressLayout.addWidget(&serverAddressLineEdit);
  serverBoxLayout.addLayout(&serverAddressLayout);
  serverPortLabel.setFixedWidth(200);
  serverPortLayout.addWidget(&serverPortLabel);
  serverPortLayout.addWidget(&serverPortLineEdit);
  serverBoxLayout.addLayout(&serverPortLayout);
  serverBoxLayout.addItem(new QSpacerItem(0, 0));

  skinBox.setFixedHeight(75);
  layout.addWidget(&skinBox);
  skinBoxLayout.addItem(new QSpacerItem(0, 83+8, QSizePolicy::Minimum, QSizePolicy::Fixed));
  skinDirLabel.setFixedWidth(200);
  skinDirLayout.addWidget(&skinDirLabel);
  skinDirLayout.addWidget(&skinDirLineEdit);
  skinBoxLayout.addLayout(&skinDirLayout);
  skinBoxLayout.addItem(new QSpacerItem(0, 0));

  layout.addItem(new QSpacerItem(0, 0));
  layout.addLayout(&buttonLayout);
  buttonLayout.addItem(new QSpacerItem(0, 0));
  okButton.setFixedWidth(100);
  cancelButton.setFixedWidth(100);
  buttonLayout.addWidget(&okButton);
  buttonLayout.addWidget(&cancelButton);

  dbgConnect( &okButton, SIGNAL(pressed()), this, SLOT(slotOk()) );
  dbgConnect( &cancelButton, SIGNAL(pressed()), this, SLOT(close()) );
}

ConfigDialog::~ConfigDialog()
{
}

void ConfigDialog::show(void)
{
  setFixedSize(500,300);

  QDialog::show();
  setResult(0);
}

void ConfigDialog::slotOk(void)
{
  Configuration::setServerIP(serverAddressLineEdit.text());
  Configuration::setServerPort(serverPortLineEdit.text().toInt());
  Configuration::setSkinDir(skinDirLineEdit.text());

  done(1);
}
