#ifndef __CONFIGURATION__H
#define __CONFIGURATION__H

#include <qdir.h>
#include <qrect.h>

#include "mpdc.h"
#include "configfile.h"

class Configuration
{
public:
  static status_t               init();
  static status_t               close();

  static QString                getSettingsRoot(void);
  static QRect                  getGeometry(QString);
  static bool                   getPlaylistVisible(void);
  static bool                   getCountMode(void);
  static QString                getSkin(void);
  static QString                getServerIP(void);
  static unsigned short         getServerPort(void);
  static QString                getSkinDir(void);

  static status_t               setGeometry(QString, QRect);
  static status_t               setPlaylistVisible(bool);
  static status_t               setCountMode(bool);
  static status_t               setSkin(QString);
  static status_t               setServerIP(QString);
  static status_t               setServerPort(unsigned short);
  static status_t               setSkinDir(QString);

private:
  static ConfigFile           * configFile;

private:
                                Configuration(void);
};

#endif
