#include <qpainter.h>

#include "gbutton.h"

GButton::GButton(bool toggle, QWidget * parent)
        :QWidget(parent),
         toggle(toggle),
         down(false),
         on(false)
{
}

void GButton::setOn(bool on)
{
  this->on = on;
  repaint(false);
}

void GButton::paintEvent(QPaintEvent *)
{
  QPainter painter(this);
  if (on && toggle)
    painter.drawPixmap(0, 0, down ? pmtPressed : pmtReleased);
  else
    painter.drawPixmap(0, 0, down ? pmPressed : pmReleased);
}

void GButton::mousePressEvent(QMouseEvent *)
{
  down = true;
  repaint(false);
  emit pressed();
}

void GButton::mouseReleaseEvent(QMouseEvent *event)
{
  down = false;
  if ((event->x() < 0) || (event->y() < 0) ||
      (event->x() >= size().width()) || (event->y() >= size().height()))\
  {
    repaint(false);
  }
  else
  {
    on = !on;
    repaint(false);
    emit clicked();
    emit toggled(on);
  }
}
