#ifndef __GBUTTON__
#define __GBUTTON__

#include <qwidget.h>
#include <qpixmap.h>

class WASkin;

class GButton : public QWidget
{
Q_OBJECT
friend class WASkin;
public:
                                GButton(bool toggle, QWidget * parent = 0);

  void                          setOn(bool);
  inline bool                   isOn(void)                                      { return on; }

protected:
  virtual void                  paintEvent(QPaintEvent *);
  virtual void                  mousePressEvent(QMouseEvent *);
  virtual void                  mouseReleaseEvent(QMouseEvent *);

signals:
  void                          pressed(void);
  void                          clicked(void);
  void                          toggled(bool);

private:
  const bool                    toggle;
  bool                          down;
  bool                          on;
  QPixmap                       pmPressed, pmReleased;
  QPixmap                       pmtPressed, pmtReleased;
};

#endif
