#include <iostream>
#include <qpainter.h>

#include "gtextview.h"

GTextView::GTextView(QWidget * parent)
          :QWidget(parent),
           text(""),
           visibleText(""),
           timer(this),
           ticks(0)
{
  connect(&timer, SIGNAL(timeout()), this, SLOT(update()));
  timer.start(150);
}

void GTextView::paintEvent(QPaintEvent *)
{
  QPainter painter(this);
  for (unsigned i=0; i<(unsigned)width(); i+=5)
  if (i/5 < visibleText.length())
  {
    char c = visibleText.latin1()[i/5];

    if ((c >= 'A') && (c <= 'Z'))        painter.drawPixmap(i, 0, pmChar[c - 'A']);
    else if ((c >= 'a') && (c <= 'z'))   painter.drawPixmap(i, 0, pmChar[c - 'a']);
    else if (c == '\"')                  painter.drawPixmap(i, 0, pmChar[26]);
    else if (c == '@')                   painter.drawPixmap(i, 0, pmChar[27]);
    else if ((c >= '0') && (c <= '9'))   painter.drawPixmap(i, 0, pmChar[c - '0' + 31]);
    else if (c == ':')                   painter.drawPixmap(i, 0, pmChar[41]);
    else if (c == '|')                   painter.drawPixmap(i, 0, pmChar[42]);
    else if (c == '=')                   painter.drawPixmap(i, 0, pmChar[43]);
    else if (c == '(')                   painter.drawPixmap(i, 0, pmChar[44]);
    else if (c == ')')                   painter.drawPixmap(i, 0, pmChar[45]);
    else if (c == '-')                   painter.drawPixmap(i, 0, pmChar[46]);
    else if (c == '\'')                  painter.drawPixmap(i, 0, pmChar[47]);
    else if (c == '!')                   painter.drawPixmap(i, 0, pmChar[48]);
    else if (c == '_')                   painter.drawPixmap(i, 0, pmChar[49]);
    else if (c == '+')                   painter.drawPixmap(i, 0, pmChar[50]);
    else if (c == '\\')                  painter.drawPixmap(i, 0, pmChar[51]);
    else if (c == '/')                   painter.drawPixmap(i, 0, pmChar[52]);
    else if (c == '[')                   painter.drawPixmap(i, 0, pmChar[53]);
    else if (c == ']')                   painter.drawPixmap(i, 0, pmChar[54]);
    else if (c == '^')                   painter.drawPixmap(i, 0, pmChar[55]);
    else if (c == '&')                   painter.drawPixmap(i, 0, pmChar[56]);
    else if (c == '%')                   painter.drawPixmap(i, 0, pmChar[57]);
    else if (c == '.')                   painter.drawPixmap(i, 0, pmChar[58]);
    else if (c == '=')                   painter.drawPixmap(i, 0, pmChar[59]);
    else if (c == '$')                   painter.drawPixmap(i, 0, pmChar[60]);
    else if (c == '#')                   painter.drawPixmap(i, 0, pmChar[61]);
    else if (c == '?')                   painter.drawPixmap(i, 0, pmChar[65]);
    else if (c == '*')                   painter.drawPixmap(i, 0, pmChar[66]);
    else                                 painter.drawPixmap(i, 0, pmChar[30]);
  }
  else
    painter.drawPixmap(i, 0, pmChar[30]);
}

void GTextView::setText(QString t)
{
  if (text != t)
    ticks = 0;

  text = t;
  repaint(false);
}

void GTextView::update(void)
{
  if ((unsigned)text.length() <= (unsigned)(width() / 5))
    visibleText = text;
  else
  {
    int offset = ticks % (text.length() + 7);
    visibleText = (text + "  ***  " + text).mid(offset, width() / 5);
    repaint(false);
  }

  ticks++;
}
