#include <iostream>
#include <qstring.h>

#include "zipio/zipio.h"

#include "zipextract.h"

ZipExtract::ZipExtract(const char *zipFile)
           :zipFile(zipFile)
{
}

QByteArray ZipExtract::extract(const char *file)
{
  ZFILE *f = zopen(zipFile.latin1(), "rb");

  do
  {
    QString name = zname(f);

    if ((name.upper() == QString(file).upper()) ||
    #if QT_VERSION >= 300
        (name.upper().endsWith("/" + QString(file).upper())))
    #else
        (name.upper().right(strlen(file)+1) == ("/" + QString(file).upper())))
    #endif
    {
      size_t offset = 0;
      QByteArray data(4096);

      while (true)
      {
        zseek(f, offset, SEEK_SET);
        size_t n = zread(data.data() + offset, 1, 4096, f);
        if (n < 4096)
        {
          zclose(f);
          return data;
        }
        else
          offset += 4096;

        data.resize(offset + 4096);
      }
    }
  } while(znext(f) == 0);

  zclose(f);
  return QByteArray();
}

